// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from polygon_msgs:msg/ComplexPolygon2DCollection.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "polygon_msgs/msg/complex_polygon2_d_collection.hpp"


#ifndef POLYGON_MSGS__MSG__DETAIL__COMPLEX_POLYGON2_D_COLLECTION__TRAITS_HPP_
#define POLYGON_MSGS__MSG__DETAIL__COMPLEX_POLYGON2_D_COLLECTION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "polygon_msgs/msg/detail/complex_polygon2_d_collection__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'polygons'
#include "polygon_msgs/msg/detail/complex_polygon2_d__traits.hpp"
// Member 'colors'
#include "std_msgs/msg/detail/color_rgba__traits.hpp"

namespace polygon_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ComplexPolygon2DCollection & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: polygons
  {
    if (msg.polygons.size() == 0) {
      out << "polygons: []";
    } else {
      out << "polygons: [";
      size_t pending_items = msg.polygons.size();
      for (auto item : msg.polygons) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: colors
  {
    if (msg.colors.size() == 0) {
      out << "colors: []";
    } else {
      out << "colors: [";
      size_t pending_items = msg.colors.size();
      for (auto item : msg.colors) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ComplexPolygon2DCollection & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: polygons
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.polygons.size() == 0) {
      out << "polygons: []\n";
    } else {
      out << "polygons:\n";
      for (auto item : msg.polygons) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: colors
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.colors.size() == 0) {
      out << "colors: []\n";
    } else {
      out << "colors:\n";
      for (auto item : msg.colors) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ComplexPolygon2DCollection & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace polygon_msgs

namespace rosidl_generator_traits
{

[[deprecated("use polygon_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const polygon_msgs::msg::ComplexPolygon2DCollection & msg,
  std::ostream & out, size_t indentation = 0)
{
  polygon_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use polygon_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const polygon_msgs::msg::ComplexPolygon2DCollection & msg)
{
  return polygon_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<polygon_msgs::msg::ComplexPolygon2DCollection>()
{
  return "polygon_msgs::msg::ComplexPolygon2DCollection";
}

template<>
inline const char * name<polygon_msgs::msg::ComplexPolygon2DCollection>()
{
  return "polygon_msgs/msg/ComplexPolygon2DCollection";
}

template<>
struct has_fixed_size<polygon_msgs::msg::ComplexPolygon2DCollection>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<polygon_msgs::msg::ComplexPolygon2DCollection>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<polygon_msgs::msg::ComplexPolygon2DCollection>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // POLYGON_MSGS__MSG__DETAIL__COMPLEX_POLYGON2_D_COLLECTION__TRAITS_HPP_
